
module MapString = Map.Make(String)

let ldd lst = 
  let dep = 
    ignore "(*(*";
    Pcre.regexp "\\s*(.*)\\s*=>\\s*(.*)\\s*\\(.*\\)\\s*"
  in
  let rec ldd_one mp fn =
    let proc = 
      Unix.open_process_in 
        (Printf.sprintf "ldd %s" (Filename.quote fn)) 
    in
    let rec read mp = 
      try 
        begin
          let ln = 
            input_line proc
          in
            try 
              let substr = Pcre.exec ~rex:dep ln in
              let tgt = ExtLib.String.strip (Pcre.get_substring substr 2) in
              let src = ExtLib.String.strip (Pcre.get_substring substr 1) in
                if tgt <> "" then
                  begin
                    let mp = 
                      if MapString.mem src mp then
                        mp
                      else
                        ldd_one 
                          (MapString.add src tgt mp)
                          tgt
                    in
                      read mp
                  end
                else
                  read mp
            with Not_found ->
              read mp
        end

      with End_of_file ->
        let _st : Unix.process_status =
          Unix.close_process_in proc
        in
          mp
    in
      read mp
  in

  let mp =
    List.fold_left ldd_one MapString.empty lst
  in
    MapString.fold
      (fun src tgt acc -> (tgt, src) :: acc)
      mp []
