(******************************************************************************)
(*  ocsigen-bundler: create self-contained Ocsigen application package        *)
(*                                                                            *)
(*  Copyright (C) 2011, OCamlCore SARL                                        *)
(*                                                                            *)
(*  This library/application is free software; you can redistribute it        *)
(*  and/or modify it under the terms of the GNU Lesser General Public         *)
(*  License as published by the Free Software Foundation; either version 2.1  *)
(*  of the License, or (at your option) any later version, with the OCaml     *)
(*  static compilation exception.                                             *)
(*                                                                            *)
(*  This library/application is distributed in the hope that it will be       *)
(*  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the file         *)
(*  COPYING for more details.                                                 *)
(*                                                                            *)
(*  You should have received a copy of the GNU Lesser General Public License  *)
(*  along with this library; if not, write to the Free Software Foundation,   *)
(*  Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA             *)
(******************************************************************************)

open OUnit
open TestCommon

let _ = 
  run_test_tt_main
    ~set_verbose:(fun v -> verbose := v) 
    ("ocsigen-bundler" >:::
     [
       "First" >::
       bracket_tmpdir 
         (fun dn ->
            Ocsigen_bundler.make (in_data_dir "ocaml-meeting.conf") dn;
            if !verbose then
              FileUtil.find FileUtil.Is_file dn (fun () -> prerr_endline) ();
            assert_bool
              "dllunix.so is present"
              (Sys.file_exists 
                 (FilePath.make_filename [dn; "lib"; "ocaml"; "stublibs"; "dllunix.so"]));
            (* TODO: chdir in assert_command *)
            bracket
              (fun () -> 
                 let pwd = FileUtil.pwd () in
                   Sys.chdir dn;
                   pwd)
              (fun _ ->
                 assert_command "./daemon.sh" ["start"];
                 assert_command "./daemon.sh" ["stop"])
              (fun pwd -> Sys.chdir pwd)
              ();
            ())
     ])
